//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
//
// FMagFactorDlg.h - small window for setting magnification factors
//                   in a fieldMap
//
// $Id: FMagFactorDlg.h,v 1.4 2001/09/11 10:08:37 goetz Exp $
//
////////////////////////////////////////////////////////////////////////

#ifndef FMAGFACTORDLG_H
#define FMAGFACTORDLG_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qlabel.h>
#include <qpushbutton.h>

#include <stdio.h>

class FieldMap;

class FMagFactorDlg : public QWidget
{
  Q_OBJECT

public:
  FMagFactorDlg(QWidget *parent=0, const char * name=0);
  ~FMagFactorDlg() {};

public slots:
  void setMagSteps( double player, double ball, double vel );
  void setDflMagSteps( double player, double ball, double vel );
 
signals:
  void magSteps( double player, double ball, double vel );

protected slots:
  void setButtonPressed();
  void fac1ButtonPressed();
  void resetButtonPressed();

private:
  QLineEdit *playerEdit;
  QLineEdit *ballEdit;
  QLineEdit *velEdit;
  
  QPushButton *abortButton;
  QPushButton *setButton;
  QPushButton *resetButton;
  QPushButton *fac1Button;
  
  double dflPlayer;
  double dflBall;
  double dflSpeed;

};

#endif
