//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef SOCKET_H
#define SOCKET_h
#include <arpa/inet.h>
#include "Exception.h"

class Socket {
  int sock;
  sockaddr_in srv;
  int maxMsgSize;
public:
  Socket(int port, const char *host, int maxMessageSize) throw (Exception);
  ~Socket() throw (Exception);

  /// enable SIGIO to get interrupted when new data is avaiable
  static void enableInts();

  string poll() throw (Exception);
  void   send(const string &) throw (Exception);

  static void myhandler(int);
};

#endif
