//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-///////////////////////////////////////////////////////////
//
// mrbcoach.h - Online coach for MRB2000
//
// $Id: mrbcoach.h,v 1.14 2001/08/02 02:28:28 mrb Exp $
//
////////////////////////////////////////////////////////////////////////

#include "onlinecoach.h"
#include "coordinates.h"
#include "tacticalmodule.h"

#ifdef RANDSUBS
#warning Random player change feature activated !!
#warning ONLY USE FOR TESTING !!!
#endif

class MrbCoach : public Onlinecoach
{
public:
  MrbCoach(const char *team, const char *host, const int port,
	   const bool logging, const char *configfile, 
	   const bool FUNSSELmode= false);
  ~MrbCoach();

  virtual void act(Snapshot *snap);
  virtual void analyze(Snapshot *snap);

private:
  bool sayMessageNow;
  play_mode lastMode;
  int countOfMsgsLeft;
  // [C]
  int thisGame;   // for counting 6000 cycle games ...
  
  int lastAumsg;
  
  TacticalModule          *tactical;

#ifdef RANDSUBS
  // the acting function for doing some strange substitutions
  // use this to check heterogenous player behaviour
  void doRandSubs(const Snapshot *snap);
  void doSub(const int player, const int type);
  void initSubs();
  void printStats(const Snapshot *snap);

  // data for subs module:
  // number of subs left in Game (after KICK_OFF !)
  // set to 0 to avoid subs in online game
  unsigned int numSubs;
  //  static unsigned int numSubs(0);
  bool initDone;
  
  // information about how many players of one type are left
  int numPlTypes;
  int *numPlType;
  
  // types for given players
  int plType[12];
#endif
}; // class MrbCoach
