//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//
// $Id: minmax.h,v 1.4 2000/10/19 15:27:46 goetz Exp $	
// $Manager: goetz$
// 
//  minmax.h - definition of simple min and max
//             and other mathematical utility functions
// 
//   Goetz Schwandtner
//
//
//////////////////////////////////////////////////////////////////////

#ifndef _MINMAX_H
#define _MINMAX_H

#ifndef LINUX

inline int min(int x, int y)
{
  return x<y ? x : y;
}

inline double min(double x, double y)
{
  return x<y ? x : y;
}


inline int max(int x, int y)
{
  return y<x ? x : y;
}

inline double max(double x, double y)
{
  return y<x ? x : y;
}

inline double sqr(double x)
{
  return x*x;
}

#endif

// a^n with n a natural number
static inline double
power( double a, int n )
{
  double b = 1;
  while (n > 0) {
    if (n & 1)
      b *= a;
    n /= 2;
    a *= a;
  }
  return b;
}

#endif
