//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-/////////////////////////////////////////////////////////
//
//  $Id: mrbtypes.h,v 1.7 2001/02/28 17:04:26 satan Exp $
// 
//  mrbtypes.h - declaration of enum types for sserver information
// 
//////////////////////////////////////////////////////////////////////


#ifndef _MRBTYPES_H_
#define _MRBTYPES_H_


enum view_width {
  VIEW_WIDTH_NARROW,
  VIEW_WIDTH_NORMAL,
  VIEW_WIDTH_WIDE
};

enum view_quality {
  VIEW_QUALITY_LOW,
  VIEW_QUALITY_HIGH
};

enum playing_side {
  SIDE_UNKNOWN = -1,
  SIDE_LEFT,
  SIDE_RIGHT
};

enum play_mode {
  PLAY_MODE_UNKNOWN = -1,
  PLAY_MODE_BEFORE_KICK_OFF = 0,
  PLAY_MODE_TIME_OVER,
  PLAY_MODE_PLAY_ON,
  PLAY_MODE_KICK_OFF_US,
  PLAY_MODE_KICK_OFF_THEM,
  PLAY_MODE_KICK_IN_US,
  PLAY_MODE_KICK_IN_THEM,
  PLAY_MODE_FREE_KICK_US,
  PLAY_MODE_FREE_KICK_THEM,
  PLAY_MODE_CORNER_KICK_US,
  PLAY_MODE_CORNER_KICK_THEM,
  PLAY_MODE_GOAL_KICK_US,
  PLAY_MODE_GOAL_KICK_THEM,
  PLAY_MODE_GOAL_US,
  PLAY_MODE_GOAL_THEM,
  PLAY_MODE_DROP_BALL,
  PLAY_MODE_OFFSIDE_US,
  PLAY_MODE_OFFSIDE_THEM,
  PLAY_MODE_HALF_TIME,
  PLAY_MODE_TIME_EXTENDED
};

enum CoachMsgType {
  CMT_FREEFORM,
  CMT_META,
  CMT_INFO,
  CMT_ADVICE,
  CMT_DEFINE,
  CMT_NONE
};

inline
class ostream & operator << (class ostream &os, const play_mode pm)
{
 switch (pm)
   {
   case PLAY_MODE_UNKNOWN:
     return os << "PLAY_MODE_UNKNOWN";
   case PLAY_MODE_BEFORE_KICK_OFF:
     return os << "PLAY_MODE_BEFORE_KICK_OFF";
   case PLAY_MODE_TIME_OVER:
     return os << "PLAY_MODE_TIME_OVER";
   case PLAY_MODE_PLAY_ON:
     return os << "PLAY_MODE_PLAY_ON";
   case PLAY_MODE_KICK_OFF_US:
     return os << "PLAY_MODE_KICK_OFF_US";
   case PLAY_MODE_KICK_OFF_THEM:
     return os << "PLAY_MODE_KICK_OFF_THEM";
   case PLAY_MODE_KICK_IN_US:
     return os << "PLAY_MODE_KICK_IN_US";
   case PLAY_MODE_KICK_IN_THEM:
     return os << "PLAY_MODE_KICK_IN_THEM";
   case PLAY_MODE_FREE_KICK_US:
     return os << "PLAY_MODE_FREE_KICK_US";
   case PLAY_MODE_FREE_KICK_THEM:
     return os << "PLAY_MODE_FREE_KICK_THEM";
   case PLAY_MODE_CORNER_KICK_US:
     return os << "PLAY_MODE_CORNER_KICK_US";
   case PLAY_MODE_CORNER_KICK_THEM:
     return os << "PLAY_MODE_CORNER_KICK_THEM";
   case PLAY_MODE_GOAL_KICK_US:
     return os << "PLAY_MODE_GOAL_KICK_US";
   case PLAY_MODE_GOAL_KICK_THEM:
     return os << "PLAY_MODE_GOAL_KICK_THEM";
   case PLAY_MODE_GOAL_US:
     return os << "PLAY_MODE_GOAL_US";
   case PLAY_MODE_GOAL_THEM:
     return os << "PLAY_MODE_GOAL_THEM";
   case PLAY_MODE_DROP_BALL:
     return os << "PLAY_MODE_DROP_BALL";
   case PLAY_MODE_OFFSIDE_US:
     return os << "PLAY_MODE_OFFSIDE_US";
   case PLAY_MODE_OFFSIDE_THEM:
     return os << "PLAY_MODE_OFFSIDE_THEM";
   case PLAY_MODE_HALF_TIME:
     return os << "PLAY_MODE_HALF_TIME";
   case PLAY_MODE_TIME_EXTENDED:
     return os << "PLAY_MODE_TIME_EXTENDED";
   default:
     return os << "PLAY_MODE: UNRECKOGNIZED !?!";
   }
}


#endif
