//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-/////////////////////////////////////////////////////////
//
//  $Id: parser.h,v 1.8 2001/03/22 10:39:45 satan Exp $
// 
//  parser.h - parsing of server messages
// 
//////////////////////////////////////////////////////////////////////


#ifndef _PARSER_H_
#define _PARSER_H_

#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <iostream.h>

#include "constants.h"
#include "sensor.h"


class Parser {
 public:

  Parser(const char *team= 0, 
	 int number= -1,
	 playing_side _side= SIDE_LEFT, 
	 bool _isCoach= false);

  ~Parser();

  void setStates(const char *team, 
		 int number, 
		 playing_side _side, 
		 bool _isCoach);

  bool parseServerString(const char *s, SensorData &data);

  play_mode parsePlayMode(const char *s);
 

 private:

  char *team;
  int number;
  playing_side side;
  bool isCoach; // true if see info is received as coach data (exact)

  bool parsePlayerType( const char *s, PlayerType &type );

  bool parseSee(const char *s, SensorData &data);
  bool parseExact(const char *s, SensorData &data);
  bool parseHear(const char *s, SensorData &data);
  bool parseCoachMsg(SensorData &data);
  bool parseSenseBody(const char *s, SensorData &data);
  bool parseGoalScore(const char *s, int &score);

  void makeValid(SensorObject &obj, 
		 double dist, double dir, 
		 double dist_change, double dir_change);
    
  void makeValid(ExactObject &obj, 
		 double x, double y, 
		 double x_vel, double y_vel);
  
};

#endif
