// -*- c++ -*- /////////////////////////////////////////////////
//
// $Id: trainer.C,v 1.7 2000/07/27 13:16:27 eri Exp $
//
// trainer.C - simple implementation of a coach client, 
//             for testing purposes
//
////////////////////////////////////////////////////////////////

#include "trainer.h"

Trainer::Trainer (const char*  team,
		  playing_side side,
		  const char*  host,
		  int          port,
		  double       MapWindowMagnify,
		  bool         logging):
Coach(team, side, host, port, MapWindowMagnify, logging) {
  
  // do whatever you need for the setup of the coach here
  
  sprintf (playername, "(player %s %d)", getMyTeam(), 1);
  
}

void
Trainer::act(Snapshot* snap) {

  AudioMsg msg;
  while (getNextMsg(msg)) {
    cout << snap->time << " received AudioMsg from sender No." 
	 << msg.getSource() << endl;
  }
  
  // "kick" ball once a free_kick_us was given.
  if (getPlayMode() == PLAY_MODE_FREE_KICK_US) {
    double moveDir;
    if (snap->ball.pos.getX() < 0) moveDir = +1;
    else moveDir = -1;
    changeMode(PLAY_MODE_PLAY_ON);
    moveObject("(ball)", snap->ball.pos.getX(), snap->ball.pos.getY(), 0,
	       moveDir * BALL_SPEED_MAX, 0);
  }
  
}
